<template>
  <div
    class="min-h-full flex items-center justify-center py-12 px-4 sm:px-6 lg:px-8"
  >
    <div
      class="max-w-lg w-full space-y-8 bg-white p-4 md:px-8 md:py-16 shadow-xl"
    >
      <div class="text-indigo-600">
        <div class="flex justify-center">
          <font-awesome-icon icon="gamepad" size="5x" />
        </div>
        <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
          Formulaire - Nouveau studio
        </h2>
      </div>
      <form class="mt-8 space-y-6" method="POST" @submit="submitStudio">
        <div class="rounded-md shadow-sm -space-y-px">
          <TextField
            label="Nom"
            id="name"
            name="name"
            type="text"
            :value="values.name"
            @input="values[$event.target.name] = $event.target.value"
            required
            placeholder="Nom du studio"
          />
        </div>

        <div class="pt-10">
          <Button type="submit" icon="lock" label="Nous rejoindre" />
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import TextField from "./Form/Field/TextField"
import Button from "./Form/ButtonForm"

export default {
  name: "StudioForm",
  components: {
    TextField,
    Button
  },
  data: () => ({
    urlStudioClaims: `https://${window.location.hostname}:8443/studio_claims`,
    urlStudio: `https://${window.location.hostname}:8443/studios`,
    values: {
      name: ""
    }
  }),
  inject: ["user", "createAlert"],
  methods: {
    submitStudio: function(e) {
      e.preventDefault()

      const headers = {
        Accept: "application/json",
        "Content-Type": "application/json",
        Authorization: "Bearer " + this.user.token
      }

      fetch(this.urlStudio, {
        headers,
        method: "POST",
        body: JSON.stringify(this.values)
      })
        .then((res) => {
          if (res.ok) {
            return res.json()
          } else {
            throw new Error("Something went wrong")
          }
        })
        .then((data) => {
          fetch(this.urlStudioClaims, {
            headers,
            method: "POST",
            body: JSON.stringify({claimer: "/users/" + this.user.id, studio: "/studios/"+data.id})
          })
            .then((res) => {
              if (res.ok) {
                return res.json()
              } else {
                throw new Error("Something went wrong")
              }
            })
            .then((data) => {
              console.log(data)
              this.createAlert({
                color: "green",
                text: "Votre demande va être étudié par un administrateur",
                icon: "check"
              })
              this.$router.push("/studio")
            })
            .catch(() => {
              this.createAlert({
                color: "red",
                text: "Une erreur est survenue",
                icon: "times"
              })
            })
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped></style>
